﻿using Infragistics.Win;
using Infragistics.Win.UltraWinTabs;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ToolbarManagerDisableDoubleClick
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += Form1_Load;

            //ultraToolbarsManager1.CreationFilter = new MyCreationFilter(ultraToolbarsManager1.Ribbon);
            

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            RibbonTab tab = ultraToolbarsManager1.Ribbon.Tabs[0];
            RibbonTabItemUIElement uiElement = tab.UIElement as RibbonTabItemUIElement;

            Application.AddMessageFilter(new MyMessageFilter());
        }
    }

    public class MyCreationFilter : IUIElementCreationFilter
    {

        private Ribbon _ribbon;
        public MyCreationFilter(Ribbon ribbon)
        {
            _ribbon = ribbon;
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            if(parent is RibbonTabItemUIElement)
            {
                RibbonTabItemUIElement element = parent as RibbonTabItemUIElement;

                PropertyInfo info = _ribbon.GetType().GetProperty("TabManager", System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance);


                TabManager manager = info.GetValue(_ribbon) as TabManager;


                MyRibbonTabItemUIElement newElement = new MyRibbonTabItemUIElement(element.Parent, _ribbon.Tabs[0], manager);

                element.Parent.ChildElements.Remove(element);
                element.Parent.ChildElements.Add(newElement);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

    public class MyRibbonTabItemUIElement : TabItemUIElement
    {
        public MyRibbonTabItemUIElement(UIElement parent, ITabItem tab, TabManager tabManager) : base(parent, tab, tabManager)
        {
        }

        protected override void OnDoubleClick(bool adjustableArea)
        {
            
        }
    }
}
